/**
 * Copyright (c) 2021 Dominic Msters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#include "dawngame.h"

game_t * gameInit(platform_t *platform) {
  // Create the game
  game_t *game = malloc(sizeof(game_t));
  if(game == NULL) return NULL;

  // Load the game engine
  game->engine = engineInit(platform, GAME_NAME, GAME_INPUT_COUNT);
  if(game->engine == NULL) {
    free(game);
    return NULL;
  }

  // Pass to the main game to handle.r
  return game;
}

void gameUpdate(game_t *game) {
  engineUpdate(game->engine);
}

void gameDispose(game_t *game) {
  engineDispose(game->engine);
  free(game);
}

engine_t * gameGetEngine(game_t *game) {
  return game->engine;
}