// Copyright (c) 2021 Dominic Msters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include <malloc.h>
#include "../engine/engine.h"

/////////////////////////////// TYPE DEFINITIONS ///////////////////////////////
/** Context about Dawn Game */
typedef struct {
  /** The engine context for the game */
  engine_t *engine;
} dawngame_t;
#define GAMETYPE_T dawngame_t


////////////////////////////// TYPE BOUND INCLUDES /////////////////////////////
#include "../engine/game/game.h"

/////////////////////////////////// CONSTANTS //////////////////////////////////
/** Name of the Game */
#define GAME_NAME "Dawn Game"

/** Inputs */
#define GAME_INPUT_UP          (inputbind_t)0x01
#define GAME_INPUT_DOWN        (inputbind_t)0x02
#define GAME_INPUT_LEFT        (inputbind_t)0x03
#define GAME_INPUT_RIGHT       (inputbind_t)0x04

#define GAME_INPUT_COUNT 5