// Copyright (c) 2021 Dominic Msters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include <malloc.h>
#include <stdint.h>

#ifndef PLATFORMINPUT_T
  #define PLATFORMINPUT_T void
#endif
/** Definition for the platform's input source */
typedef PLATFORMINPUT_T platforminput_t;

/**
 * Contains information about the running platform. Essentially this is just
 * some context as to what is running the game engine itself. It's mostly for
 * metadata purposes but there may be some technical information required for
 * the engine.
 */
typedef struct {
  /** Internal name of the platform */
  char *name;

  /** Dimensions of the screen (in pixels) */
  uint32_t screenWidth, screenHeight;

  int32_t inputSourceCount;
  float *inputValues;
  platforminput_t *inputSource;
} platform_t;